#!/bin/sh

set -e

regen=""
verbose=""
if [ "$1" = "--regen" ]; then
    regen=yes
    shift
fi
if [ "$1" = "-v" ]; then
    verbose=yes
    shift
fi

do_cmp()
{
    cmd="$1"
    baseline=$2
    if [ "$regen" = "yes" ]; then
	eval "$cmd" > $baseline || true
    elif [ "$verbose" = "yes" ]; then
	eval "$cmd" | diff -c $baseline -
    else
	eval "$cmd" | cmp $baseline -
    fi
}

echo "test-1: sniffer"
do_cmp "../wrenrx-sniff stdin ex1.bin -- -t -t" ex1.txt

echo "test-2: generator"
do_cmp "../wrentx-simple stdout -- -d 0 -f ../ex1.wrtg" ex1.bin

echo "test-3: wrenrx-get (pulse)"
do_cmp "../wrenrx-get stdin ex1.bin -- -S 0 -e 2,e0==7 -e 1," test3.out

echo "test-4: wrenrx-get (pulse)"
do_cmp "../wrenrx-get stdin ex1.bin -- -S 0 -e 2,e0==7 -e 1, -e 1,c5==2" test4.out

echo "test-5: wrenrx-get (event)"
do_cmp "../wrenrx-get stdin ex1.bin -- -S 0 -s 0x2" test5.out

echo "test-6: wrentx-simple large packet"
do_cmp "../wrentx-simple stdout -- -d 0 -f ./large1.txt" test6.out

echo "test-7: wrentx-simple truncate packet on param"
do_cmp "../wrentx-simple stdout -- -d 0 -f ./large1-param.txt" test7.out

echo "test-8: wrentx-simple truncate packet on event"
do_cmp "../wrentx-simple stdout -- -d 0 -f ./large1-ev.txt" test8.out

echo "test-9: wrentx-simple send a very simple table"
do_cmp "../wrentx-simple stdout -- -d 0 -f ./test9.txt" test9.out

echo "test-10: wrentx-simple send a table with a wait"
do_cmp "../wrentx-simple dump -- -d 0 -f ./test10.txt" test10.out

echo "test-11: wrentx-simple send a table with a loop"
do_cmp "../wrentx-simple dump -- -d 0 -f ./test11.txt" test11.out

echo "test-12: wrentx-simple stop a table"
do_cmp "../wrentx-simple dump -- -d 0 -f ./test12.txt" test12.out

echo "test-13: wrentx-simple start a table on event"
do_cmp "../wrentx-simple dump -- -d 0 -f ./test13.txt" test13.out

echo "test-14: wrentx-simple start 2 chained tables on event"
do_cmp "../wrentx-simple dump -- -d 0 -f ./test14.txt" test14.out

echo "test-15: wrentx-simple trigger a table on event generated by played table"
do_cmp "../wrentx-simple dump -- -d 0 -f ./test15.txt" test15.out

echo "test-16: wrentx-simple trigger a table after a wait in a table"
do_cmp "../wrentx-simple dump -- -d 0 -f ./test16.txt" test16.out

echo "test-17: wrentx-simple play table that was not loaded"
do_cmp "../wrentx-simple dump -- -d 0 -f ./test17.txt 2>&1" test17.out

echo "test-18: wrentx-simple play an invalid table"
do_cmp "../wrentx-simple dump -- -d 0 -f ./test18.txt 2>&1" test18.out

echo "test-19: wrentx-simple start a table on cond event"
do_cmp "../wrentx-simple dump -- -d 0 -f ./test19.txt" test19.out

echo "test-20: wrentx-simple with many contexts"
do_cmp "../wrentx-simple stdout -- -d 0 -f test20.txt" test20.bin

echo "test-21: wrenrx-get with many contexts"
do_cmp "../wrenrx-get stdin test20.bin -- -S 0" test21.out

echo "test-22: wrentx-simple with a source id"
do_cmp "../wrentx-simple stdout -- -d 7 -f test10.txt" test22.bin

echo "test-23: wrenrx-sniff with source id"
do_cmp "../wrenrx-sniff stdin test22.bin --" test23.out

echo "test-24: wrenrx-get susbscribe with source id"
do_cmp "../wrenrx-get stdin test22.bin -- -S 7 -s 2" test24.out

echo "test-25: wrenrx-get susbscribe with source id and incremented idx"
do_cmp "../wrenrx-get stdin test22.bin -- -I -S 7 -s 2" test25.out

echo "test-26: wrenrx-get pulse on any param (from event)"
do_cmp "../wrenrx-get stdin ex1.bin -- -S 0 -e 2,a0==7" test26.out

echo "test-27: wrenrx-get pulse on any param (from context)"
do_cmp "../wrenrx-get stdin ex1.bin -- -S 0 -e 2,a1==4" test27.out

echo "Tests ok"
